Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs	(revision 15509)
@@ -501,64 +661,197 @@
         string.Format("Invalid decimal G30 number format \"{0}\" could not be parsed", s));
     }
+
     private static string FormatG30(decimal d) {
       return d.ToString("g30", CultureInfo.InvariantCulture);
     }
   }
-  #endregion
-
-  #region String
-  [Transformer("E75A594C-0034-4DAB-B28E-8F84F9F6DE8D", 218)]
-  [StorableType("ba52fce8-bf0c-47ad-95dd-df5d9281942d")]
-  internal sealed class StringTransformer : UnsignedIntBoxTransformer<string> {
-    protected override uint ToBoxType(string value, Mapper mapper) { return mapper.GetStringId(value); }
-    protected override string ToValueType(uint value, Type type, Mapper mapper) { return mapper.GetString(value); }
-  }
-  #endregion
-
-  #region Enum
-  [Transformer("93FF076B-BC4B-4C39-8C40-15E004468C98", 219)]
-  [StorableType("f8a7dbb4-e1ce-4db8-905e-f3a05f5ca000")]
-  internal sealed class EnumTransformer : Transformer {
+
+  [Transformer("1C6C350F-B2C8-40F0-A964-54DDB0D087A3", 401)]
+  [StorableType("9D99D155-E3BB-40CE-AF64-6E153D876148")]
+  internal sealed class DateTimeBoxTransformer : BoxTransformer<DateTime> {
+    protected override void Populate(Box box, DateTime value, Mapper mapper) {
+      box.Long = value.Ticks;
+    }
+
+    protected override DateTime Extract(Box box, Type type, Mapper mapper) {
+      return new DateTime(box.Long);
+    }
+  }
+
+  [Transformer("964074C9-4B82-4725-97AF-612A193EA5C6", 402)]
+  [StorableType("9CA7C1F7-784C-48D5-A6F4-E1FD7B3A2FEC")]
+  internal sealed class TimeSpanBoxTransformer : BoxTransformer<TimeSpan> {
+    protected override void Populate(Box box, TimeSpan value, Mapper mapper) {
+      box.Long = value.Ticks;
+    }
+
+    protected override TimeSpan Extract(Box box, Type type, Mapper mapper) {
+      return new TimeSpan(box.Long);
+    }
+  }
+
+  [Transformer("B0C0165B-6279-4CC3-8DB7-D36898BFBC38", 403)]
+  [StorableType("ED6B7AE1-CE2B-4891-9BF3-72F5D1D67D93")]
+  internal sealed class PointTransformer : BoxTransformer<Point> {
+    protected override void Populate(Box box, Point value, Mapper mapper) {
+      var intArrayBox = new IntArrayBox();
+      intArrayBox.Values.AddRange(new[] { value.X, value.Y });
+      box.BoxId = mapper.GetIntArrayBoxId(intArrayBox);
+    }
+
+    protected override Point Extract(Box box, Type type, Mapper mapper) {
+      var intArrayBox = mapper.GetIntArrayBox(box.BoxId);
+      return new Point(intArrayBox.Values[0], intArrayBox.Values[1]);
+    }
+  }
+
+  [Transformer("D0ADB806-2DFD-459D-B5DA-14B5F1152534", 404)]
+  [StorableType("B13D6153-E71D-4B76-9893-81D3570403E8")]
+  internal sealed class BitmapTransformer : BoxTransformer<Bitmap> {
+    protected override void Populate(Box box, Bitmap value, Mapper mapper) {
+      lock (value)
+        using (var ms = new MemoryStream()) {
+          value.Save(ms, ImageFormat.Png);
+          box.Bytes = ByteString.CopyFrom(ms.ToArray());
+        }
+    }
+
+    protected override Bitmap Extract(Box box, Type type, Mapper mapper) {
+      using (var ms = new MemoryStream()) {
+        ms.Write(box.Bytes.ToArray(), 0, box.Bytes.Length);
+        ms.Seek(0, SeekOrigin.Begin);
+        return new Bitmap(ms);
+      }
+    }
+  }
+
+  [Transformer("AFF27987-3301-4D70-9601-EFCA31BDA0DB", 405)]
+  [StorableType("B9F9A371-4DCB-478B-B0D4-6F87A15C02B5")]
+  internal sealed class FontTransformer : BoxTransformer<Font> {
+    protected override void Populate(Box box, Font value, Mapper mapper) {
+      var unsignedIntArrayBox = new UnsignedIntArrayBox();
+      unsignedIntArrayBox.Values.Add(mapper.GetStringId(GetFontFamilyName(value.FontFamily)));
+      unsignedIntArrayBox.Values.Add(mapper.GetBoxId(value.Size));
+      unsignedIntArrayBox.Values.Add(mapper.GetBoxId(value.Style));
+      unsignedIntArrayBox.Values.Add(mapper.GetBoxId(value.Unit));
+      unsignedIntArrayBox.Values.Add(mapper.GetBoxId(value.GdiCharSet));
+      unsignedIntArrayBox.Values.Add(mapper.GetBoxId(value.GdiVerticalFont));
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(unsignedIntArrayBox);
+    }
+
+    protected override Font Extract(Box box, Type type, Mapper mapper) {
+      var value = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      var fontData = value.Values;
+      return new Font(
+        GetFontFamily(mapper.GetString(fontData[0])),
+        (float)mapper.GetObject(fontData[1]),
+        (FontStyle)mapper.GetObject(fontData[2]),
+        (GraphicsUnit)mapper.GetObject(fontData[3]),
+        (byte)mapper.GetObject(fontData[4]),
+        (bool)mapper.GetObject(fontData[5])
+      );
+    }
+
+    public const string GENERIC_MONOSPACE_NAME = "_GenericMonospace";
+    public const string GENERIC_SANS_SERIF_NAME = "_GenericSansSerif";
+    public const string GENERIC_SERIF_NAME = "_GenericSerif";
+
+    public static FontFamily GetFontFamily(string name) {
+      if (name == GENERIC_MONOSPACE_NAME) return FontFamily.GenericMonospace;
+      if (name == GENERIC_SANS_SERIF_NAME) return FontFamily.GenericSansSerif;
+      if (name == GENERIC_SERIF_NAME) return FontFamily.GenericSerif;
+      return new FontFamily(name);
+    }
+
+    public static string GetFontFamilyName(FontFamily ff) {
+      if (ff.Equals(FontFamily.GenericMonospace)) return GENERIC_MONOSPACE_NAME;
+      if (ff.Equals(FontFamily.GenericSansSerif)) return GENERIC_SANS_SERIF_NAME;
+      if (ff.Equals(FontFamily.GenericSerif)) return GENERIC_SERIF_NAME;
+      return ff.Name;
+    }
+  }
+
+  [Transformer("D912D573-CE41-40B8-8F95-646C183662F6", 406)]
+  [StorableType("3ED2C12F-BE41-45F5-AA0A-C2F23EB99FBD")]
+  internal sealed class KeyValuePairBoxTransformer : BoxTransformer<object> {
     public override bool CanTransformType(Type type) {
-      return typeof(Enum).IsAssignableFrom(type);
-    }
-
-    public override Box ToBox(object o, Mapper mapper) {
-      var boxBuilder = Box.CreateBuilder();
-      var enumBuilder = new UnsignedIntBox.Builder();
-
-      boxBuilder.TransformerId = mapper.GetTransformerId(this);
-      boxBuilder.TypeId = mapper.GetStringId(o.GetType().AssemblyQualifiedName);
-      enumBuilder.Value = mapper.GetStringId(Enum.Format(o.GetType(), o, "G"));
-
-      boxBuilder.SetExtension(UnsignedIntBox.UnsignedInt, enumBuilder.Build());
-      return boxBuilder.Build();
-    }
-
-    public override object ToObject(Box box, Mapper mapper) {
-      uint value = box.GetExtension(UnsignedIntBox.UnsignedInt).Value;
-      return Enum.Parse(Type.GetType(mapper.GetString(box.TypeId)), mapper.GetString(value));
-    }
-  }
-  #endregion
-
-  #region Struct
-  [Transformer("89DAAFC5-726C-48D4-A4E0-2B0D27329642", 220)]
-  [StorableType("c3c4ad38-7110-439c-b73c-d33466db3db4")]
-  internal sealed class StructTransformer : Transformer {
+      return type.IsGenericType && (type.GetGenericTypeDefinition() == typeof(KeyValuePair<,>));
+    }
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
+      var unsignedIntArrayBox = new UnsignedIntArrayBox();
+      var type = value.GetType();
+      var pair = new uint[2];
+      pair[0] = mapper.GetBoxId(type.GetProperty("Key").GetValue(value));
+      pair[1] = mapper.GetBoxId(type.GetProperty("Value").GetValue(value));
+      unsignedIntArrayBox.Values.AddRange(pair);
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(unsignedIntArrayBox);
+    }
+
+    public override void FillFromBox(object obj, Box box, Mapper mapper) {
+      var b = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      var key = mapper.GetObject(b.Values[0]);
+      var val = mapper.GetObject(b.Values[1]);
+      var type = obj.GetType();
+      //DataMemberAccessor.GenerateFieldSetter(type.GetField("key", BindingFlags.NonPublic | BindingFlags.Instance))(obj, key);
+      //DataMemberAccessor.GenerateFieldSetter(type.GetField("value", BindingFlags.NonPublic | BindingFlags.Instance))(obj, val);
+      type.GetField("key", BindingFlags.NonPublic | BindingFlags.Instance).SetValue(obj, key);
+      type.GetField("value", BindingFlags.NonPublic | BindingFlags.Instance).SetValue(obj, val);
+    }
+
+    protected override object Extract(Box box, Type type, Mapper mapper) {
+      return Activator.CreateInstance(type);
+    }
+  }
+
+  [Transformer("BBA08D33-FDA4-4EB6-8D94-9BF3D30C3E11", 407)]
+  [StorableType("B0333A12-7D91-47A5-ACD4-49E43E5A18DC")]
+  internal sealed class TupleBoxTransformer : BoxTransformer<object> {
+    private static readonly HashSet<Type> supportedTypes = new HashSet<Type> {
+      typeof(Tuple<>), typeof(Tuple<,>), typeof(Tuple<,,>), typeof(Tuple<,,,>),
+      typeof(Tuple<,,,,>), typeof(Tuple<,,,,,>), typeof(Tuple<,,,,,,>), typeof(Tuple<,,,,,,,>)
+    };
+
+    public override bool CanTransformType(Type type) {
+      return type.IsGenericType && supportedTypes.Contains(type.GetGenericTypeDefinition());
+    }
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
+      var type = value.GetType();
+      var uIntArrayBox = new UnsignedIntArrayBox();
+      for (int i = 1; i <= type.GetGenericArguments().Length; i++) {
+        string name = string.Format("Item{0}", i);
+        uIntArrayBox.Values.Add(mapper.GetBoxId(type.GetProperty(name).GetValue(value)));
+      }
+      box.BoxId = mapper.GetUnsignedIntArrayBoxId(uIntArrayBox);
+    }
+
+    protected override object Extract(Box box, Type type, Mapper mapper) {
+      var defaultValues = type.GetGenericArguments().Select(x =>
+        x.IsValueType ? Activator.CreateInstance(x) : null
+      ).ToArray();
+      return Activator.CreateInstance(type, defaultValues);
+    }
+
+    public override void FillFromBox(object obj, Box box, Mapper mapper) {
+      var uIntArrayBox = mapper.GetUnsignedIntArrayBox(box.BoxId);
+      var elements = uIntArrayBox.Values.Select(mapper.GetObject).ToArray();
+      var type = obj.GetType();
+      for (int i = 1; i <= elements.Length; i++) {
+        string name = string.Format("m_Item{0}", i);
+        DataMemberAccessor.GenerateFieldSetter(type.GetField(name, BindingFlags.NonPublic | BindingFlags.Instance))(obj, elements[i - 1]);
+      }
+    }
+  }
+
+  [Transformer("731F9A18-6BF4-43BE-95CF-8205552C9B70", 500)]
+  [StorableType("73FCDE79-436D-476E-B2EA-A7A1A4A810B5")]
+  internal sealed class StructBoxTransformer : BoxTransformer<object> {
     public override bool CanTransformType(Type type) {
       return type.IsValueType && !type.IsPrimitive && !type.IsEnum && type.IsSealed;
     }
-    public override Box ToBox(object o, Mapper mapper) {
-      var box = Box.CreateBuilder();
-      box.TransformerId = mapper.GetTransformerId(this);
-      Populate(box, o, mapper);
-      return box.Build();
-    }
-    public override object ToObject(Box box, Mapper mapper) {
-      return Extract(box, (Type)mapper.GetObject(box.TypeId), mapper);
-    }
-    private void Populate(Box.Builder box, object value, Mapper mapper) {
-      var b = StorableClassBox.CreateBuilder();
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
+      var b = new StorableClassBox();
       var type = value.GetType();
 
@@ -569,17 +862,18 @@
       }
 
-      b.AddRangeKeyIds(components.Keys);
-      b.AddRangeValueIds(components.Values);
-
-      box.TypeId = mapper.GetBoxId(type);
-      box.SetExtension(StorableClassBox.StorableClass, b.Build());
-    }
-    private object Extract(Box box, Type type, Mapper mapper) {
-      var data = box.GetExtension(StorableClassBox.StorableClass);
+      foreach (var component in components) {
+        b.KeyValuePairs.Add(component.Key, component.Value);
+      }
+
+      box.BoxId = mapper.GetStorableClassBoxId(b);
+    }
+
+    protected override object Extract(Box box, Type type, Mapper mapper) {
+      var data = mapper.GetStorableClassBox(box.BoxId);
       var obj = Activator.CreateInstance(type);
 
       var components = new Dictionary<uint, uint>();
-      for (int i = 0; i < data.KeyIdsList.Count; i++) {
-        components.Add(data.KeyIdsList[i], data.ValueIdsList[i]);
+      foreach (var kvp in data.KeyValuePairs) {
+        components.Add(kvp.Key, kvp.Value);
       }
 
